config/routes.rb
if ENV['RAILS_RELATIVE_URL_ROOT']
  Rails.application.routes.default_scope = ENV['RAILS_RELATIVE_URL_ROOT']
end

Rails.application.routes.draw do
  get 'up', to: ->(env) { [204, {}, ['']] }

  # ------------------------------------------------------------ Authentication
  # Sign in / sign out
  get '/login'  => 'sessions#new'
  get '/logout' => 'sessions#destroy'
  resource :session

  resources :comments

  # ------------------------------------------------------------ Project routes
  concern :multiple_destroy do
    collection do
      delete :multiple_destroy
    end
  end

  concern :multiple_update do
    collection do
      patch :multiple_update
    end
  end

  concern :previewable do
    member do
      post :preview
    end
  end

  resources :notifications, only: [:index, :update]

  resources :projects, only: [:index, :show] do
    resources :activities, only: [:index] do
      collection do
        get :poll, constraints: { format: /js/ }
      end
    end

    resources :boards do
      resources :lists, except: [:index] do
        member { post :move }
        resources :cards, except: [:index] do
          member { post :move }
          resources :revisions, only: [:index, :show]
        end
      end
    end

    constraints id: %r{[(0-z)\/]+} do
      resources :configurations, only: [:index, :update]
    end

    post :create_multiple_evidence, to: 'issues/evidence#create_multiple'

    resources :issues, concerns: [:multiple_destroy, :previewable] do
      collection do
        post :import
        resources :merge, only: [:new, :create], controller: 'issues/merge'
      end

      resources :evidence, concerns: :multiple_destroy, controller: 'issues/evidence', only: [:index, :new]
      resources :nodes, only: [:show], controller: 'issues/nodes'
      resources :revisions, only: [:index, :show]
    end

    resources :methodologies do
      collection { post :preview }
      member do
        get :add
        put :update_task
      end
    end

    resources :nodes do
      collection do
        post :sort
        post :create_multiple
      end

      member do
        get :tree
      end

      resource :merge, only: [:create], controller: 'nodes/merge'

      resources :notes, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      resources :evidence, except: :index, concerns: [:multiple_destroy, :previewable] do
        resources :revisions, only: [:index, :show]
      end

      constraints(filename: /.*/) do
        resources :attachments, only: [:index, :show, :create, :destroy], param: :filename
      end
    end

    resources :notifications, only: [:index, :update]

    resources :revisions, only: [] do
      member { post :recover }
    end

    resources :tags, except: [:show] do
      collection { post :sort }
    end

    namespace :qa do
      resources :issues, only: [:edit, :index, :show, :update], concerns: [:multiple_update, :previewable]
    end

    get 'search' => 'search#index'
    get 'trash' => 'revisions#trash'

    # ------------------------------------------------------- Export Manager
    get  '/export' => 'export#index', as: :export_manager

    # ------------------------------------------------------- Upload Manager
    get  '/upload'        => 'upload#index',  as: :upload_manager
    post '/upload'        => 'upload#create'
    post '/upload/parse'  => 'upload#parse'

    if Rails.env.development?
      get '/styles' => 'styles_tylium#index'
    end
  end

  resources :console, only: [] do
    collection { get :status }
  end

  resource :fields, only: [] do
    collection do
      get :field
      post :form
      post :source
    end
  end

  namespace :setup, only: [:index] do
    if defined?(Dradis::Pro)
    else
      resource :password, only: [:new, :create]
    end
    resource :kit, only: [:new, :create]
  end

  resources :subscriptions, only: [:index, :create, :destroy]

  # -------------------------------------------------------------- Static pages
  resource :markup, controller: :markup, only: [] do
    get :help
    post :preview
  end

  if defined?(Dradis::Pro)
  else
    root to: 'setup/passwords#new'
  end

  mount ActionCable.server => '/cable'
end

app/models/note.rb
# A Note in dradis is the basic unit of information. It has a :text and an
# :author field that capture the contents of the Note and the creator.
#
# In Dradis 2.x notes have a fixed set of fields (:text, :author, :category,
# :node). However, it is expected that in Dradis 3.x it will be possible to
# configure this list of fields to match the needs of the users.
#
# In the interim, Dradis 2.x Note objects use a special syntax in their :text
# field to define different fields. This syntax is as follows:
#
#   #[Title]#
#   Directory Listings
#
#   #[Description]#
#   Some directories on the server were configured [...]
#
# The syntax above would result in the call to the fields method to return a
# Hash with two elements:
#
#   {
#     'Title' => 'Directory Listings',
#     'Description' => 'Some directories on the server were configured [...]',
#   }
#
#
# This behaviour is extensively used by import/export plugins such as WordExport.
class Note < ApplicationRecord
  include Commentable
  include HasFields
  include RevisionTracking
  include Subscribable

  alias_attribute :content, :text

  dradis_has_fields_for :text

  # FIXME - ISSUE?/NOTE INHERITANCE
  # Issues have QA states but notes don't currently use states.
  # Since Issue is an extension of Note, notes have a state column too.
  # We need to define the enum here so that states can be referenced whether
  # the Note or the Issue is pulled when calling Activity.includes(:trackable).
  # (Since we're not using STI, .includes only joins the class of the most recent
  # Activity instead of pulling the correct class (Note/Issue) for each activity)
  enum state: [:draft, :ready_for_review, :published]

  # -- Relationships --------------------------------------------------------
  belongs_to :category
  belongs_to :node, touch: true
  has_many :activities, as: :trackable

  delegate :project, :project=, to: :node

  # -- Callbacks ------------------------------------------------------------
  # FIXME - ISSUE/NOTE INHERITANCE
  # `has_many :comments, dependent: :destroy` and
  # `has_many :subscriptions, dependent: :destroy`
  # are not working properly for `Issue`, because we're not using STI.
  # Also, we put the callback in the parent `Note` model, so when we destroy
  # a project (a project `has_many :notes` but not `has_many :issues`), and the
  # destroyed objects are loaded as `Note`, we make sure its comments/subscriptions
  # are destroyed if the record really is an `Issue`
  after_destroy do
    Comment.where(commentable_type: 'Issue', commentable_id: id).destroy_all
    Subscription.where(subscribable_type: 'Issue', subscribable_id: id).destroy_all
  end

  # -- Validations ----------------------------------------------------------
  validates :category, presence: true
  validates :node, presence: true
  validates :text, length: { maximum: DB_MAX_TEXT_LENGTH }

  # -- Scopes ---------------------------------------------------------------
  scope :recently_created, -> { where(['notes.created_at > ?', 1.day.ago]) }
  scope :recently_updated, -> { where(['notes.updated_at > ?', 1.day.ago]) }

  # -- Class Methods --------------------------------------------------------

  # -- Instance Methods -----------------------------------------------------

  def field_or_text(field_name)
    fields.fetch(field_name, text.truncate(20))
  end

  ActiveSupport.run_load_hooks(:note_model, self)
end

app/controllers/notes_controller.rb
# This controller exposes the REST operations required to manage the Note
# resource.
class NotesController < NestedNodeResourceController
  include AttachmentsCopier
  include ConflictResolver
  include LiquidEnabledResource
  include Mentioned
  include MultipleDestroy
  include NodesSidebar
  include NotificationsReader

  before_action :find_or_initialize_note, except: [:index, :multiple_destroy]
  before_action :initialize_nodes_sidebar, only: [:edit, :new, :show]
  before_action :set_auto_save_key, only: [:new, :create, :edit, :update]

  def new
    # See ContentFromTemplate concern
    @note.text = template_content if params[:template]
  end

  # Create a new Note for the associated Node.
  def create
    @note.author = current_user.email
    @note.category ||= Category.default

    if @note.save
      track_created(@note)
      redirect_to project_node_note_path(current_project, @node, @note), notice: 'Note created'
    else
      initialize_nodes_sidebar
      render 'new'
    end
  end

  # Retrieve a Note given its :id
  def show
    load_conflicting_revisions(@note)
  end

  def edit
    @versions_count = @note.versions.count
    @form_preview_path = preview_project_node_note_path(current_project, @node, @note)
  end

  # Update the attributes of a Note
  def update
    updated_at_before_save = @note.updated_at.to_i

    @note.assign_attributes(note_params)
    copy_attachments(@note) if @note.node_changed?

    if @note.save
      track_updated(@note)
      check_for_edit_conflicts(@note, updated_at_before_save)
      # if the note has just been moved to another node, we must reload
      # here so that @note.node is correct and we redirect to the right URL
      @note.reload
      redirect_to project_node_note_path(current_project, @note.node, @note), notice: 'Note updated.'
    else
      initialize_nodes_sidebar
      render 'edit'
    end
  end

  # Remove a Note from the back-end database.
  def destroy
    if @note.destroy
      track_destroyed(@note)
      redirect_to project_node_path(current_project, @node), notice: 'Note deleted'
    else
      redirect_to project_node_note_path(current_project, @node, @note), alert: 'Could not delete note'
    end
  end

  private

  # Once a valid @node is set by the previous filter we look for the Note we
  # are going to be working with based on the :id passed by the user.
  def find_or_initialize_note
    if params[:id]
      @note = @node.notes.find(params[:id])
    elsif params[:note]
      @note = @node.notes.new(note_params)
    else
      @note = @node.notes.new
    end
  end

  def liquid_resource_assigns
    { 'note' => NoteDrop.new(@note) }
  end

  def note_params
    params.require(:note).permit(:category_id, :text, :node_id)
  end

  def set_auto_save_key
    @auto_save_key = if @note&.persisted?
      "note-#{@note.id}"
    elsif params[:template]
      "node-#{@node.id}-note-#{params[:template]}"
    else
      "node-#{@node.id}-note"
    end
  end
end

app/views/notes/_actions.html.erb
<div class="actions">
  <span class="action">
    <%= link_to edit_project_node_note_path(@node.project, @node, @note) do %>
      <i class="fa-solid fa-pencil fa-fw"></i> Edit
    <% end %>
  </span>
  <li class="dropdown dots-dropdown">
    <a href="#" class="dropdown-toggle" data-bs-toggle="dropdown"><i class="fa-solid fa-ellipsis-h fa-lg"></i><span class="visually-hidden">Toggle menu</span></a>
    <div class="dropdown-menu">
      <%= link_to [current_project, @node, @note],
        class: 'dropdown-item text-error-hover',
        data: { confirm: "Are you sure?\n\nProceeding will delete this note from the associated node." },
        method: :delete do %>
        <i class="fa-solid fa-trash fa-fw"></i> Delete
      <% end %>
      <a href="#modal_move_note" class="dropdown-item" tabindex="-1" data-bs-toggle="modal"><i class="fa-solid fa-mail-forward fa-fw"></i> Move</a>
      <%= render partial: 'subscriptions/actions', locals: { subscribable: @note, dots_menu: true } %>
      <%= link_to(project_node_note_revisions_path(@node.project, @node, @note), class: 'dropdown-item') do %>
        <i class="fa-solid fa-history fa-fw"></i> View History
      <% end %>
    </div>
  </li>
</div>

app/views/notes/_breadcrumbs.html.erb
<nav>
  <ol class="breadcrumb">
    <li class="breadcrumb-item"><a href="javascript:void(0)" data-behavior="sidebar-toggle">Nodes</a></li>
    <li class="breadcrumb-item" data-node-id="<%= @node.id %>"><%= link_to @node.label, main_app.project_node_path(@node.project, @node, tab: 'notes-tab') %></li>
    <%= content_tag :li, class: 'breadcrumb-item active' do %><%= @note.persisted? ? @note.title : 'New Note' %><% end -%>
  </ol>
</nav>

app/views/notes/_form.html.erb
<%= simple_form_for [current_project, @node, @note],
  html: {
    data: {
      behavior: 'local-auto-save',
      auto_save_key: @auto_save_key
    }
  } do |f| %>

  <%= f.hidden_field :category, value: Category.default.id %>

  <%= f.label :text, 'Note source input', class: 'visually-hidden' %>
  <%=
    f.input :text,
      label: false,
      input_html: {
        class: 'textile',
        data: {
          allow_dropdown: @note.new_record?,
          behavior: 'auto-save rich-toolbar drop-zone',
          paths: editor_paths,
          'rich-toolbar': 'block-code bold field image italic link list-ol list-ul table',
          'rich-toolbar-uploader': '[data-behavior~=jquery-upload]',
        },
        rows: 20
      }
  %>

  <% if @note.persisted? %>
    <%= hidden_field :note, :original_updated_at, value: @note.updated_at.to_i %>
  <% end %>

  <div class="form-actions">
    <%= f.button :submit, class: 'btn btn-primary' %> or
    <%=
      link_to 'Cancel',
      @note.new_record? ? project_node_path(@node.project, @node) : project_node_note_path(@node.project, @node, @note),
      class: 'cancel-link',
      data: {
        behavior: 'clear-local-auto-save'
      }
    %>
  </div>
<% end %>

app/views/notes/_note.html.erb
<%
  item_css = ['list-item']
  item_css << ' active' if (request.format.html? and @note == note)
%>

<%= content_tag :div, id: "#{dom_id(note)}_link", class: item_css.join do %>

  <%= link_to project_node_note_path(@node.project, @node, note) do %>
    <i class="fa-solid fa-file-text list-item-icon"></i>
    <%= note.title %>
  <% end %>

  <div class="list-item-actions">
    <%= link_to edit_project_node_note_path(@node.project, @node, note), class:'list-item-action-edit' do %>
      <i class="fa-solid fa-pencil"></i> Edit
    <% end %>

    <%= link_to [@node.project, @node, note],
          method: :delete,
          data: { confirm: "Are you sure?\n\nProceeding will delete this note from the associated node." },
          class: 'list-item-action-delete' do %>
      <i class="fa-solid fa-trash"></i> Delete
    <% end %>
  </div>

<% end %>

app/views/notes/edit.html.erb
<% content_for :title, "#{@node.label} - edit note" %>

<% content_for :breadcrumbs do %>
  <nav>
    <%= render partial: 'breadcrumbs' %>
  </nav>
<% end %>

<div class="content-container">
  <h4 class="header-underline">Edit note</h4>
  <div class="note-text-inner">
    <%= render "form" %>
  </div>
</div>

app/views/notes/multiple_destroy.json.erb
<% if @count > @max_deleted_inline %>
{
  "success": true,
  "jobId": "<%= @job_logger.uid %>"
}
<% elsif @count > 0 %>
{
  "success": true,
  "msg": "<%= "Notes deleted" %>"
}
<% else %>
{
  "success": false,
  "msg": "<%= "Error deleting notes" %>"
}
<% end %>

app/views/notes/new.html.erb
<% content_for :title, "#{@node.label} - add note" %>

<% content_for :breadcrumbs do %>
  <nav>
    <%= render partial: 'breadcrumbs' %>
  </nav>
<% end %>

<div class="content-container">
  <h4 class="header-underline">Add note</h4>
  <div class="note-text-inner">
    <%= render "form" %>
  </div>
</div>

app/views/notes/show.html.erb
<% content_for :title, "#{@node.label} - view note" %>

<% if @conflicting_revisions %>
  <%= render "projects/conflicting_revisions", conflicts: @conflicting_revisions, record: @note %>
<% end %>

<% content_for :breadcrumbs do %>
  <%= render partial: 'breadcrumbs' %>
<% end %>

<ul class="tabs-container nav nav-tabs main-tabs">
  <li class="nav-item"><a class="nav-link active" href="#info-tab" data-bs-toggle="tab"><i class="fa-solid fa-file-text"></i> Note</a></li>
</ul>

<div class="row m-0">
  <div class="col-12 col-xxl-7 p-0">
    <div class="content-container mt-0 pb-3 me-xxl-3">
      <div class="tab-content mt-0">
        <div class="tab-pane active" id="info-tab">
          <% cache ['note-information-tab', @note] do %>
            <div id="<%= dom_id(@note) %>" class="note-text-inner">
              <h4 class="header-underline">
                <span class="text-truncate" title="<%= @note.title %>"><%= @note.title %></span>
                <%= render partial: 'shared/liquid_loading' %>
                <%= render partial: 'actions' %>
              </h4>
              <%= render partial: 'shared/textile_content', locals: { record: @note, preview_path: preview_project_node_note_path(current_project, @note.node, @note) } %>
              <div class="author-info">
                <span class="ms-auto">Author: <%= @note.author || 'n/a' %></span>
              </div>
            </div>
          <% end %>
        </div>
      </div>
    </div>
  </div>
  <div class="col-12 col-xxl-5 p-0">
    <div class="sticky-top">
      <div class="content-container ms-xxl-3 mt-0">
        <%= content_tag :div,
          spinner_tag,
          data: {
            behavior: 'fetch fetch-comments',
            path: comments_path(
              comment: {
                commentable_type: @note.class,
                commentable_id: @note.id
              }
            )
          }
        %>
      </div>

      <div class="content-container ms-xxl-3">
        <%= content_tag :div,
          spinner_tag,
          data: {
            behavior: 'fetch fetch-subscriptions',
            path: subscriptions_path(
              subscription: {
                subscribable_type: @note.class,
                subscribable_id: @note.id
              }
            )
          }
        %>
      </div>
    </div>
  </div>
</div>